
/*******************************************************************************
*
* File lattice.h
*
* Copyright (C) 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef LATTICE_H
#define LATTICE_H

#ifndef SU3_H
#include "su3.h"
#endif

/* BCNDS_C */
extern int *bnd_pts(int *n);
extern void avg_cd0(int n,su3_alg_dble *cd,su3_alg_dble *ct0);
extern void set_adbc(int n,su3_alg_dble *ad);
extern void set_cdbc(int n,su3_alg_dble *cd);
extern void set_sdbc(int n,spinor_dble *sd);
extern void set_udbc(int n,su3_dble *ud);
extern int check_adbc(int n,su3_alg_dble *ad);
extern int check_cdbc(int n,su3_alg_dble *cd);
extern int check_sdbc(int n,spinor_dble *sd);
extern int check_udbc(int n,su3_dble *ud);

/* GEOMETRY_C */
extern int ipr_global(int *n);
extern void ipt_global(int *x,int *ip,int *ix);
extern int global_time(int ix);
extern void geometry(void);

#endif
