
/*******************************************************************************
*
* File linalg.h
*
* Copyright (C) 2011, 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef LINALG_H
#define LINALG_H

#ifndef SU3_H
#include "su3.h"
#endif

/* CMATRIX_DBLE_C */
extern void cmat_vec_dble(int n,complex_dble *a,complex_dble *v,
                          complex_dble *w);
extern void cmat_vec_assign_dble(int n,complex_dble *a,complex_dble *v,
                                 complex_dble *w);
extern void cmat_add_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_sub_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_mul_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_dag_dble(int n,complex_dble *a,complex_dble *b);
extern int cmat_inv_dble(int n,complex_dble *a,complex_dble *b,double *k);

/* LIEALG_C */
extern void random_alg(int vol,su3_alg_dble *X);
extern double norm_square_alg(int vol,int icom,su3_alg_dble *X);
extern double scalar_prod_alg(int vol,int icom,su3_alg_dble *X,su3_alg_dble *Y);
extern void set_alg2zero(int vol,su3_alg_dble *X);
extern void assign_alg2alg(int vol,su3_alg_dble *X,su3_alg_dble *Y);
extern void swap_alg(int vol,su3_alg_dble *X,su3_alg_dble *Y);
extern void add_alg(int vol,su3_alg_dble *X,su3_alg_dble *Y);
extern void sub_alg(int vol,su3_alg_dble *X,su3_alg_dble *Y);
extern void mulr_alg(int vol,double r,su3_alg_dble *X,su3_alg_dble *Y);
extern void mulr_add_alg(int vol,double r,su3_alg_dble *X,su3_alg_dble *Y);
extern void set_ualg2zero(int vol,u3_alg_dble *X);
extern void assign_ualg2ualg(int vol,u3_alg_dble *X,u3_alg_dble *Y);
extern void add_ualg(int vol,u3_alg_dble *X,u3_alg_dble *Y);
extern void sub_ualg(int vol,u3_alg_dble *X,u3_alg_dble *Y);

#endif
