
/*******************************************************************************
*
* File mdint.h
*
* Copyright (C) 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef MDINT_H
#define MDINT_H

#ifndef SU3_H
#include "su3.h"
#endif

typedef enum
{
   TP,TU,TO,TG,TR,
   TOPS
} top_t;

typedef struct
{
   top_t top;
   int ifr;
   double eps;
} mdstep_t;

/* GDAMP_C */
extern void apply_gdfld1(int n,double c,su3_alg_dble *om,su3_dble *ud);
extern void apply_gdfld2(int n,double c,su3_alg_dble *om,su3_alg_dble *mom,
                         su3_dble *ud);
extern void add_gdfrc(int n,double c1,double c2,su3_dble *ud,su3_alg_dble *om);

/* MDSTEPS_C */
extern void set_mdsteps(void);
extern mdstep_t *mdsteps(int *nop);
extern void print_mdsteps(int ipr);

/* MDINT_C */
extern void start_smd(int n,su3_alg_dble *om,su3_alg_dble *mom,su3_dble *ud);
extern void run_mdint(int n,su3_alg_dble *om,su3_alg_dble *mom,su3_dble *ud,
                      int idH,double *dH);
extern double renormalize_ud(int n,su3_dble *ud);

/* MFLDS_C */
extern void random_mom(int n,su3_alg_dble *mom);
extern void rotate_mom(int n,double co,double si,su3_alg_dble *mom);
extern void mom_action(int icom,int n,su3_alg_dble *mom,double *S);

#endif
